<?php

declare(strict_types = 1);

namespace Drupal\Tests\entity_visibility_preview\Traits;

use Drupal\field\Entity\FieldConfig;
use Drupal\field\Entity\FieldStorageConfig;

/**
 * Provides common methods to tests.
 */
trait EntityVisibilityPreviewTestHelperTrait {

  /**
   * Test user.
   *
   * @var \Drupal\user\UserInterface
   */
  protected $user;

  /**
   * Helper function to create the field storage.
   *
   * @throws \Drupal\Core\Entity\EntityStorageException
   */
  protected function createFieldStorage() {
    FieldStorageConfig::create([
      'field_name' => 'field_entity_visibility_preview',
      'entity_type' => 'node',
      'type' => 'entity_visibility_preview',
      'settings' => [],
      'cardinality' => 1,
    ])->save();
  }

  /**
   * Helper function to create the field config.
   *
   * @throws \Drupal\Core\Entity\EntityStorageException
   */
  protected function createFieldConfig() {
    $field_config = FieldConfig::create([
      'field_name' => 'field_entity_visibility_preview',
      'label' => 'Entity visibility preview',
      'entity_type' => 'node',
      'bundle' => 'article',
      'required' => FALSE,
      'settings' => isset($this->fieldSettings) ? $this->fieldSettings : [],
    ]);
    $field_config->save();
  }

}
